#include <windows.h>
#include <commctrl.h>
#include "common.h"

void FillByZero(void* p, DWORD s)
{
	while(s--)
		*((BYTE*)p)++ = 0;

	return;
}

HMENU MenuToPopup(HMENU hm)
{
	HMENU hpopup;
	UINT i, max;

	hpopup = CreatePopupMenu();
	max = GetMenuItemCount(hm);
	for(i = 0; i < max; i++)
	{
		MENUITEMINFO mii;
		TCHAR ts[256];

		mii.cbSize = sizeof(mii);
		mii.fMask = MIIM_CHECKMARKS | MIIM_DATA | MIIM_ID | MIIM_STATE | MIIM_SUBMENU | MIIM_TYPE;
		mii.fType = MFT_STRING;	// TODO: ?
		mii.dwTypeData = ts;
		mii.cch = sizeof(ts) - 2;
		/*
		mii.fState = 0;
		mii.wID = 0;
		mii.hSubMenu = NULL;
		mii.hbmpChecked = NULL;
		mii.hbmpUnchecked = NULL;
		mii.dwItemData = 0;
		*/

		GetMenuItemInfo(hm, i, TRUE, &mii);
		InsertMenuItem(hpopup, i, TRUE, &mii);
	}

	DestroyMenu(hm);

	return hpopup;
}

int TBGetIndexFromID(HWND twnd, int id)
{
	int count = SendMessage(twnd, TB_BUTTONCOUNT, 0, 0);
	int i;

	for(i = 0; i < count; i++)
	{
		TBBUTTON tb;

		SendMessage(twnd, TB_GETBUTTON, i, (LPARAM)&tb);

		if(tb.idCommand == id)
			return i;
	}

	return -1;
}

LPCTSTR basename(LPCTSTR str)
{
	LPCTSTR last = str;

	while(*str)
	{
		if(*str == TEXT('\\'))
			last = str + 1;
		str = CharNext(str);
	}

	return last;
}

BOOL WritePrivateProfileInt(LPCTSTR lpAppName, LPCTSTR lpKeyName, int num, LPCTSTR lpFileName)
{
	TCHAR ts[16];

	wsprintf(ts, TEXT("%d"), num);

	return WritePrivateProfileString(lpAppName, lpKeyName, ts, lpFileName);
}

BOOL addEndYen(LPTSTR str)
{
	LPTSTR p;
	int chrs, lastyen;

	for(p = str, chrs = 0, lastyen = 0; *p; p = CharNext(p), chrs++)
	{
		if(*p == TEXT('\\'))
			lastyen = chrs;
	}

	if(lastyen < chrs - 1)
	{
		lstrcat(str, TEXT("\\"));
		return TRUE;
	}

	return FALSE;
}

LPCTSTR lstrstr(LPCTSTR str, LPCTSTR pattern)
{
	// TODO: Unicodeœ
#ifdef UNICODE
#error "Sorry, lstrstr not supported UNICODE environment..."
#endif
	LPCTSTR p;

	for(p = str; *p; CharNext(p))
	{
		LPCTSTR q = p, r = pattern;

		while(*q && *r && *q == *r)
		{
			q = CharNext(q);
			r = CharNext(r);
		}

		if(!*r)
			return p;
	}

	return NULL;
}

LPTSTR lstrlwr(LPTSTR str)
{
	LPTSTR first = str;
	// ԂUnicodełƎv...
//#ifdef UNICODE
//#error "Sorry, lstrstr not supported UNICODE environment..."
//#endif
	while(*str)
	{
		if('A' <= *str && *str <= 'Z')
			(*str) += 'a' - 'A';
		str = CharNext(str);
	}

	return first;
}

BOOL cutEndYen(LPTSTR str)
{
	LPTSTR p, lyp;
	int chrs, lastyen;

	for(p = str, chrs = 0, lastyen = 0; *p; p = CharNext(p), chrs++)
	{
		if(*p == TEXT('\\'))
		{
			lastyen = chrs;
			lyp = p;
		}
	}

	if(lastyen == chrs - 1)
	{
		*lyp = TEXT('\0');
		return TRUE;
	}

	return FALSE;
}

/*
LPTSTR lstrdup(LPCTSTR str)
{
	UINT len = lstrlen(str);
	LPTSTR newstr;

	newstr = halloc((len + 1) * sizeof(TCHAR));
	lstrcpy(newstr, str);

	return newstr;
}
*/

LPTSTR lstrdupplus(LPCTSTR str, UINT plus)
{
	UINT len = lstrlen(str);
	LPTSTR newstr;

	newstr = halloc((len + 1 + plus) * sizeof(TCHAR));
	lstrcpy(newstr, str);

	return newstr;
}

LPCTSTR lastchar(LPCTSTR str, TCHAR chr)
{
	LPCTSTR last = NULL;

	while(*str)
	{
		if(*str == chr)
			last = str;
		str = CharNext(str);
	}

	return last;
}

// TODO: Unicode/ANSI0`9͘A?
DWORD strToDword(LPCTSTR str)
{
	LPCTSTR p;
	DWORD val = 0;

	for(p = str; TEXT('0') <= *p && *p <= TEXT('9'); p++)
	{
		val *= 10;
		val += *p - TEXT('0');
	}

	return val;
}

// from BM2
LPCTSTR lstrchr(LPCTSTR str, TCHAR chr)
{
	LPCTSTR p;

	for(p = str; !chr || *p; p = CharNext(p))
	{
		if(*p == chr)
			return p;
	}

	return NULL;
}

// from BM2
BOOL makedir(LPCTSTR dir)
{
	TCHAR precurdir[MAX_PATH];
	TCHAR tdir[MAX_PATH];
	LPTSTR p;

	if(!GetCurrentDirectory(sizeof(precurdir), precurdir))
		return FALSE;

	for(p = tdir; ; )
	{
		lstrcpy(tdir, dir);
		addEndYen(tdir);

		if(!(p = (LPTSTR)lstrchr(p, TEXT('\\'))))
			break;

		p++;
		*p = TEXT('\0');

		// ݂̂ScreateDirectory!!
		//if(!CreateDirectory(tdir, NULL) && GetLastError() != ERROR_ALREADY_EXISTS)
		//	return FALSE;
		CreateDirectory(tdir, NULL);
	}

	if(!SetCurrentDirectory(precurdir))
		return FALSE;

	return TRUE;
}
